// pages/login/login.js
const app = getApp()
const util = require("../../utils/util")
Page({

  /**
   * 页面的初始数据
   */
  data: {

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    this.getVersion()
  },

  //判断版本号
  getVersion: function () {
    util.doPost(
      'getVersion', {
        appId: app.globalData.appId
      }
    ).then(res => {
      if (res.version != app.globalData.ver) {
        wx.setStorageSync('isShow', false)
        wx.switchTab({
          url: '/pages/index/index',
        })
      } else {
        wx.setStorageSync('isShow', true)
        this.getOpenId()
      }
    })
  },

  // 登录
  getOpenId: function () {
    wx.login({
      success: res => {
        util.doPost(
          'getOpenId', {
          appId: app.globalData.appId,
          code: res.code
        },
        ).then(res => {
          if (res.success == 1) {
            wx.setStorageSync('openId', res.data.openId)
            wx.hideLoading({
            })
          }
        })
      },
      fail: res => {
        wx.hideLoading({
          success: (res) => {
            wx.showToast({
              title: '提示',
              icon: 'none',
              content: '连接失败，请重试'
            })
          },
        })
      }
    })
  },

  //授权手机号
  getPhoneNumber: function (e) {
    const that = this;
    if (e.detail.errMsg == "getPhoneNumber:ok") {
      wx.showLoading({
        title: '正在登陆',
        mask: true
      })
      util.doPost(
        'getPhoneNumber', {
        encryptedData: e.detail.encryptedData,
        iv: e.detail.iv,
        openId: wx.getStorageSync('openId'),
      }
      ).then(rs => {
        if (rs.success > 0) {
          wx.setStorageSync('phone', rs.data.phoneNumber);
          // wx.setStorageSync('phone', '13871019618')
          this.autoLogin();
        } else {
          wx.showToast({
            title: '手机号验证失败',
          })
        }
      })
    }
    that.setData({
      model: false,
      localtion: true
    })
  },

  autoLogin: function () {
    util.doPost(
      'autoLogin', {
      openId: wx.getStorageSync('openId'),
    }
    ).then(rs => {
      wx.hideLoading()
      if (rs.success > 0) {
        wx.setStorageSync('sso-token', rs.data.token);
        wx.showToast({
          title: '登录成功',
        })
        wx.switchTab({
          url: '/pages/index/index'
        })
        // wx.navigateTo({
        //   url: '/pages/doTask/doTask',
        // })
      } else {
        wx.showToast({
          title: rs.errMsg,
          icon: 'none',
          duration: 3000
        })
      }
    })
  },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },



  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})